diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-phy.cc ns-3.36/src/wifi/model/wifi-phy.cc
--- ns-3.35/src/wifi/model/wifi-phy.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-phy.cc	2022-04-30 18:23:58.218735200 -0700
@@ -1066,54 +815,51 @@
 }
 
 void
-WifiPhy::ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band)
+WifiPhy::ConfigureStandard (WifiStandard standard)
 {
-  NS_LOG_FUNCTION (this << standard << band);
-  m_standard = standard;
-  m_band = band;
+  NS_LOG_FUNCTION (this << standard);
 
-  if (m_initialFrequency == 0 && m_initialChannelNumber == 0)
-    {
-      // set a default channel if the user did not specify anything
-      if (m_initialChannelWidth == 0)
-        {
-          // set a default channel width
-          m_initialChannelWidth = GetDefaultChannelWidth (m_standard, m_band);
-        }
+  NS_ABORT_MSG_IF (m_standard != WIFI_STANDARD_UNSPECIFIED && standard != m_standard,
+                   "Cannot change standard");
 
-      m_operatingChannel.SetDefault (m_initialChannelWidth, m_standard, m_band);
-    }
-  else
+  m_standard = standard;
+
+  if (!m_operatingChannel.IsSet ())
     {
-      m_operatingChannel.Set (m_initialChannelNumber, m_initialFrequency, m_initialChannelWidth,
-                              m_standard, m_band);
+      NS_LOG_DEBUG ("Setting the operating channel first");
+      SetOperatingChannel (m_channelSettings);
+      // return because we are called back by SetOperatingChannel
+      return;
     }
-  m_operatingChannel.SetPrimary20Index (m_initialPrimary20Index);
+
+  // this function is called when changing PHY band, hence we have to delete
+  // the previous PHY entities
+  m_phyEntities.clear ();
 
   switch (standard)
     {
-    case WIFI_PHY_STANDARD_80211a:
+    case WIFI_STANDARD_80211a:
       Configure80211a ();
       break;
-    case WIFI_PHY_STANDARD_80211b:
+    case WIFI_STANDARD_80211b:
       Configure80211b ();
       break;
-    case WIFI_PHY_STANDARD_80211g:
+    case WIFI_STANDARD_80211g:
       Configure80211g ();
       break;
-    case WIFI_PHY_STANDARD_80211p:
+    case WIFI_STANDARD_80211p:
       Configure80211p ();
       break;
-    case WIFI_PHY_STANDARD_80211n:
+    case WIFI_STANDARD_80211n:
       Configure80211n ();
       break;
-    case WIFI_PHY_STANDARD_80211ac:
+    case WIFI_STANDARD_80211ac:
       Configure80211ac ();
       break;
-    case WIFI_PHY_STANDARD_80211ax:
+    case WIFI_STANDARD_80211ax:
       Configure80211ax ();
       break;
-    case WIFI_PHY_STANDARD_UNSPECIFIED:
+    case WIFI_STANDARD_UNSPECIFIED:
     default:
       NS_ASSERT_MSG (false, "Unsupported standard");
       break;
@@ -1127,8 +873,8 @@
 }
 
 
-WifiPhyStandard
-WifiPhy::GetPhyStandard (void) const
+WifiStandard
+WifiPhy::GetStandard (void) const
 {
   return m_standard;
 }
@@ -1139,127 +885,51 @@
   return m_operatingChannel;
 }
 
-void
-WifiPhy::SetFrequency (uint16_t frequency)
-{
-  NS_LOG_FUNCTION (this << frequency);
-
-  if (!m_operatingChannel.IsSet ())
-    {
-      // ConfigureStandardAndBand has not been called yet, so store the frequency
-      // into m_initialFrequency
-      NS_LOG_DEBUG ("Saving frequency configuration for initialization");
-      m_initialFrequency = frequency;
-      return;
-    }
-
-  if (GetFrequency () == frequency)
-    {
-      NS_LOG_DEBUG ("No frequency change requested");
-      return;
-    }
-
-  // if the frequency does not uniquely identify an operating channel,
-  // the simulation aborts
-  SetOperatingChannel (0, frequency, 0);
-}
-
 uint16_t
 WifiPhy::GetFrequency (void) const
 {
   return m_operatingChannel.GetFrequency ();
 }
 
-void
-WifiPhy::SetChannelNumber (uint8_t nch)
-{
-  NS_LOG_FUNCTION (this << +nch);
-
-  if (!m_operatingChannel.IsSet ())
-    {
-      // ConfigureStandardAndBand has not been called yet, so store the channel
-      // into m_initialChannelNumber
-      NS_LOG_DEBUG ("Saving channel number configuration for initialization");
-      m_initialChannelNumber = nch;
-      return;
-    }
-
-  if (GetChannelNumber () == nch)
-    {
-      NS_LOG_DEBUG ("No channel change requested");
-      return;
-    }
-
-  // if the channel number does not uniquely identify an operating channel,
-  // the simulation aborts
-  SetOperatingChannel (nch, 0, 0);
-}
-
 uint8_t
 WifiPhy::GetChannelNumber (void) const
 {
   return m_operatingChannel.GetNumber ();
 }
 
-void
-WifiPhy::SetChannelWidth (uint16_t channelWidth)
-{
-  NS_LOG_FUNCTION (this << channelWidth);
-
-  if (channelWidth != 0)
-    {
-      AddSupportedChannelWidth (channelWidth);
-    }
-
-  if (!m_operatingChannel.IsSet ())
-    {
-      // ConfigureStandardAndBand has not been called yet, so store the channel width
-      // into m_initialChannelWidth
-      NS_LOG_DEBUG ("Saving channel width configuration for initialization");
-      m_initialChannelWidth = channelWidth;
-      return;
-    }
-
-  if (GetChannelWidth () == channelWidth)
-    {
-      NS_LOG_DEBUG ("No channel width change requested");
-      return;
-    }
-
-  NS_ABORT_MSG ("The channel width does not uniquely identify an operating channel.");
-}
-
 uint16_t
 WifiPhy::GetChannelWidth (void) const
 {
   return m_operatingChannel.GetWidth ();
 }
 
+uint8_t
+WifiPhy::GetPrimary20Index (void) const
+{
+  return m_operatingChannel.GetPrimaryChannelIndex (20);
+}
+
 void
-WifiPhy::SetPrimary20Index (uint8_t index)
+WifiPhy::SetOperatingChannel (const ChannelTuple& channelTuple)
 {
-  NS_LOG_FUNCTION (this << +index);
+  // the generic operator<< for tuples does not give a pretty result
+  NS_LOG_FUNCTION (this << +std::get<0> (channelTuple) << std::get<1> (channelTuple)
+                   << static_cast<WifiPhyBand> (std::get<2> (channelTuple))
+                   << +std::get<3> (channelTuple));
 
-  if (!m_operatingChannel.IsSet ())
+  m_channelSettings = channelTuple;
+
+  if (m_standard == WIFI_STANDARD_UNSPECIFIED)
     {
-      // ConfigureStandardAndBand has not been called yet, so store the primary20
-      // index into m_initialPrimary20Index
-      NS_LOG_DEBUG ("Saving primary20 index configuration for initialization");
-      m_initialPrimary20Index = index;
+      NS_LOG_DEBUG ("Channel information will be applied when a standard is configured");
       return;
     }
 
-  m_operatingChannel.SetPrimary20Index (index);
-}
-
-void
-WifiPhy::SetOperatingChannel (uint8_t number, uint16_t frequency, uint16_t width)
-{
   Time delay = Seconds (0);
 
   if (IsInitialized ())
     {
-      delay = DoChannelSwitch ();
+      delay = GetDelayUntilChannelSwitch ();
     }
 
   if (delay.IsStrictlyNegative ())
@@ -1270,33 +940,17 @@
   if (delay.IsStrictlyPositive ())
     {
       // switching channel has been postponed
-      Simulator::Schedule (delay, &WifiPhy::SetOperatingChannel, this, number, frequency, width);
+      void (WifiPhy::*fp) (const ChannelTuple&) = &WifiPhy::SetOperatingChannel;
+      Simulator::Schedule (delay, fp, this, channelTuple);
       return;
     }
 
   // channel can be switched now.
-  uint16_t prevChannelWidth = 0;
-  if (m_operatingChannel.IsSet ())
-    {
-      prevChannelWidth = GetChannelWidth ();
-    }
-
-  m_operatingChannel.Set (number, frequency, width, m_standard, m_band);
-
-  if (GetChannelWidth () != prevChannelWidth)
-    {
-      AddSupportedChannelWidth (GetChannelWidth ());
-
-      // If channel width changed after initialization, invoke the capabilities changed callback
-      if (IsInitialized () && !m_capabilitiesChangedCallback.IsNull ())
-        {
-          m_capabilitiesChangedCallback ();
-        }
-    }
+  DoChannelSwitch ();
 }
 
 Time
-WifiPhy::DoChannelSwitch (void)
+WifiPhy::GetDelayUntilChannelSwitch (void)
 {
   m_powerRestricted = false;
   m_channelAccessRequested = false;
@@ -1328,6 +982,7 @@
       break;
     case WifiPhyState::CCA_BUSY:
     case WifiPhyState::IDLE:
+      m_endPhyRxEvent.Cancel ();
       for (auto & phyEntity : m_phyEntities)
         {
           phyEntity.second->CancelAllEvents ();
@@ -1342,10 +997,53 @@
       break;
     }
 
-  if (delay.IsZero ())
+  return delay;
+}
+
+void
+WifiPhy::DoChannelSwitch (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  // Update unspecified parameters with default values
+  if (auto& [number, width, band, primary20] = m_channelSettings; true)
+    {
+      if (band == static_cast<int> (WIFI_PHY_BAND_UNSPECIFIED))
+        {
+          band = static_cast<int> (GetDefaultPhyBand (m_standard));
+        }
+      if (width == 0 && number == 0)
+        {
+          width = GetDefaultChannelWidth (m_standard, (WifiPhyBand)(band));
+        }
+      if (number == 0)
+        {
+          number = WifiPhyOperatingChannel::GetDefaultChannelNumber (width, m_standard, (WifiPhyBand)(band));
+        }
+    }
+
+  // We need to call SetStandard if this is the first time we set a channel or we
+  // are changing PHY band. Checking if the new PHY band is different than the
+  // previous one covers both cases because initially the PHY band is unspecified
+  bool changingPhyBand = (static_cast<WifiPhyBand> (std::get<2> (m_channelSettings)) != m_band);
+
+  m_band = static_cast<WifiPhyBand> (std::get<2> (m_channelSettings));
+
+  NS_LOG_DEBUG ("switching channel");
+  m_operatingChannel.Set (std::get<0> (m_channelSettings), 0, std::get<1> (m_channelSettings),
+                          m_standard, m_band);
+  m_operatingChannel.SetPrimary20Index (std::get<3> (m_channelSettings));
+
+  if (changingPhyBand)
+    {
+      ConfigureStandard (m_standard);
+    }
+
+  AddSupportedChannelWidth (GetChannelWidth ());
+
+  if (IsInitialized ())
     {
-      // channel switch can be done now
-      NS_LOG_DEBUG ("switching channel");
+      // notify channel switching
       m_state->SwitchToChannelSwitching (GetChannelSwitchDelay ());
       m_interference.EraseEvents ();
       /*
@@ -1356,8 +1054,6 @@
       * out the state of the medium after the switching.
       */
     }
-
-  return delay;
 }
 
 void
@@ -1793,7 +1489,7 @@
 }
 
 void
-WifiPhy::Send (WifiConstPsduMap psdus, WifiTxVector txVector)
+WifiPhy::Send (WifiConstPsduMap psdus, const WifiTxVector& txVector)
 {
   NS_LOG_FUNCTION (this << psdus << txVector);
   /* Transmission can happen if:
@@ -1819,16 +1515,6 @@
         }
       return;
     }
-  
-  // Set RU PHY indices
-  if (txVector.IsMu ())
-    {
-      for (auto& heMuUserInfo : txVector.GetHeMuUserInfoMap ())
-        {
-          heMuUserInfo.second.ru.SetPhyIndex (txVector.GetChannelWidth (),
-                                              m_operatingChannel.GetPrimaryChannelIndex (20));
-        }
-    }
 
   Time txDuration = CalculateTxDuration (psdus, txVector, GetPhyBand ());
 
@@ -2322,4 +2008,10 @@
   return os;
 }
 
+uint8_t
+WifiPhy::GetPrimaryChannelNumber (uint16_t primaryChannelWidth) const
+{
+  return m_operatingChannel.GetPrimaryChannelNumber (primaryChannelWidth, m_standard);
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-phy-common.h ns-3.36/src/wifi/model/wifi-phy-common.h
--- ns-3.35/src/wifi/model/wifi-phy-common.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-phy-common.h	2022-04-30 18:23:58.218735200 -0700
@@ -267,6 +267,8 @@
   RXING,
   TXING,
   SLEEPING,
+  POWERED_OFF,
+  TRUNCATED_TX,
   BUSY_DECODING_PREAMBLE,
   PREAMBLE_DETECT_FAILURE,
   RECEPTION_ABORTED_BY_TX,
@@ -302,6 +304,10 @@
         return (os << "TXING");
       case SLEEPING:
         return (os << "SLEEPING");
+      case POWERED_OFF:
+        return (os << "OFF");
+      case TRUNCATED_TX:
+        return (os << "TRUNCATED_TX");
       case BUSY_DECODING_PREAMBLE:
         return (os << "BUSY_DECODING_PREAMBLE");
       case PREAMBLE_DETECT_FAILURE:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-phy.h ns-3.36/src/wifi/model/wifi-phy.h
--- ns-3.35/src/wifi/model/wifi-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-phy.h	2022-04-30 18:23:58.218735200 -0700
@@ -32,7 +32,7 @@
 namespace ns3 {
 
 class Channel;
-class NetDevice;
+class WifiNetDevice;
 class MobilityModel;
 class WifiPhyStateHelper;
 class FrameCaptureModel;
@@ -58,8 +58,6 @@
   WifiPhy ();
   virtual ~WifiPhy ();
 
-  static const std::set<FrequencyChannelInfo> m_frequencyChannels;  //!< Available frequency channels
-
   /**
    * Return the WifiPhyStateHelper of this PHY
    *
@@ -149,7 +147,7 @@
    *        this PSDU, and txPowerLevel, a power level to use to send the whole PPDU. The real transmission
    *        power is calculated as txPowerMin + txPowerLevel * (txPowerMax - txPowerMin) / nTxLevels
    */
-  void Send (WifiConstPsduMap psdus, WifiTxVector txVector);
+  void Send (WifiConstPsduMap psdus, const WifiTxVector& txVector);
 
   /**
    * \param ppdu the PPDU to send
@@ -472,29 +470,6 @@
   WifiMode GetMcs (WifiModulationClass modulation, uint8_t mcs) const;
 
   /**
-   * \brief Set channel number.
-   *
-   * Channel center frequency = Channel starting frequency + 5 MHz * (nch - 1)
-   *
-   * where Starting channel frequency is standard-dependent,
-   * as defined in (Section 18.3.8.4.2 "Channel numbering"; IEEE Std 802.11-2012).
-   *
-   * If the operating channel for this object has not been set yet, the given
-   * channel number is saved and will be used, along with the center frequency and
-   * width that have been saved similarly, to set the operating channel when the
-   * standard and band are configured. Note that if center frequency and channel
-   * number are both 0 when the standard and band are configured, a default channel
-   * (of the configured width, if any, or the default width for the current standard
-   * and band, otherwise) is set.
-   * If the operating channel for this object has been already set, the specified
-   * channel number must uniquely identify a channel in the band being used. If so,
-   * this method may still fail to take action if the PHY model determines that
-   * the channel number cannot be switched for some reason (e.g. sleep state)
-   *
-   * \param id the channel number
-   */
-  virtual void SetChannelNumber (uint8_t id);
-  /**
    * Return current channel number.
    *
    * \return the current channel number
@@ -509,16 +484,15 @@
    * Configure the PHY-level parameters for different Wi-Fi standard.
    *
    * \param standard the Wi-Fi standard
-   * \param band the Wi-Fi band
    */
-  virtual void ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band);
+  virtual void ConfigureStandard (WifiStandard standard);
 
   /**
    * Get the configured Wi-Fi standard
    *
    * \return the Wi-Fi standard that has been configured
    */
-  WifiPhyStandard GetPhyStandard (void) const;
+  WifiStandard GetStandard (void) const;
 
   /**
    * Get the configured Wi-Fi band
@@ -823,13 +797,13 @@
    *
    * \param device the device this PHY is associated with
    */
-  void SetDevice (const Ptr<NetDevice> device);
+  void SetDevice (const Ptr<WifiNetDevice> device);
   /**
    * Return the device this PHY is associated with
    *
    * \return the device this PHY is associated with
    */
-  Ptr<NetDevice> GetDevice (void) const;
+  Ptr<WifiNetDevice> GetDevice (void) const;
   /**
    * \brief assign a mobility model to this device
    *
@@ -852,44 +826,29 @@
    */
   Ptr<MobilityModel> GetMobility (void) const;
 
+  using ChannelTuple = std::tuple<uint8_t /* channel number */,
+                                  uint16_t /* channel width */,
+                                  int /* WifiPhyBand */,
+                                  uint8_t /* primary20 index*/>;  //!< Tuple identifying an operating channel
+
   /**
-   * Set the operating channel according to the specified parameters. If this object
-   * has been already initialized, setting the operating channel involves a channel
-   * switch, which might be suppressed (e.g., if this object is in sleep mode) or
-   * delayed (e.g., if this object is transmitting a frame).
-   *
-   * \param number the channel number (use 0 to leave it unspecified)
-   * \param frequency the channel center frequency in MHz (use 0 to leave it unspecified)
-   * \param width the channel width in MHz (use 0 to leave it unspecified)
-   */
-  void SetOperatingChannel (uint8_t number, uint16_t frequency, uint16_t width);
-  /**
-   * If the operating channel for this object has not been set yet, the given
-   * center frequency is saved and will be used, along with the channel number and
-   * width that have been saved similarly, to set the operating channel when the
-   * standard and band are configured. Note that if center frequency and
-   * channel number are both 0 when the standard and band are configured, a default
-   * channel (of the configured width, if any, or the default width for the current
-   * standard and band, otherwise) is set.
-   * If the operating channel for this object has been already set, the specified
-   * center frequency must uniquely identify a channel in the band being used. If so,
-   * this method may still fail to take action if the PHY model determines that
-   * the operating channel cannot be switched for some reason (e.g. sleep state)
+   * If the standard for this object has not been set yet, store the given channel
+   * settings. Otherwise, check if a channel switch can be performed now. If not,
+   * schedule another call to this method when channel switch can be performed.
+   * Otherwise, set the operating channel based on the given channel settings and
+   * call ConfigureStandard if the PHY band has changed.
    *
-   * \param freq the operating center frequency (MHz) on this node.
+   * \param channelTuple the given channel settings
    */
-  virtual void SetFrequency (uint16_t freq);
+  void SetOperatingChannel (const ChannelTuple& channelTuple);
   /**
    * \return the operating center frequency (MHz)
    */
   uint16_t GetFrequency (void) const;
   /**
-   * Set the index of the primary 20 MHz channel (0 indicates the 20 MHz subchannel
-   * with the lowest center frequency).
-   *
-   * \param index the index of the primary 20 MHz channel
+   * \return the index of the primary 20 MHz channel
    */
-  void SetPrimary20Index (uint8_t index);
+  uint8_t GetPrimary20Index (void) const;
   /**
    * \param antennas the number of antennas on this node.
    */
@@ -969,21 +928,6 @@
    */
   uint16_t GetChannelWidth (void) const;
   /**
-   * If the operating channel for this object has not been set yet, the given
-   * channel width is saved and will be used, along with the center frequency and
-   * channel number that have been saved similarly, to set the operating channel
-   * when the standard and band are configured. Note that if center frequency and
-   * channel number are both 0 when the standard and band are configured, a default
-   * channel (of the configured width, if any, or the default width for the current
-   * standard and band, otherwise) is set.
-   * Do not call this method when the standard and band of this object have been
-   * already configured, because it cannot uniquely identify a channel in the band
-   * being used.
-   *
-   * \param channelWidth the channel width (in MHz)
-   */
-  virtual void SetChannelWidth (uint16_t channelWidth);
-  /**
    * \param width the channel width (in MHz) to support
    */
   void AddSupportedChannelWidth (uint16_t width);
@@ -1101,6 +1045,14 @@
    */
   virtual std::tuple<double, double, double> GetTxMaskRejectionParams (void) const = 0;
 
+  /**
+   * Get channel number of the primary channel
+   * \param primaryChannelWidth the width of the primary channel (MHz)
+   *
+   * \return channel number of the primary channel
+   */
+  uint8_t GetPrimaryChannelNumber (uint16_t primaryChannelWidth) const;
+
 protected:
   virtual void DoDispose (void);
 
@@ -1118,7 +1070,11 @@
    *         be performed or a negative value indicating that channel switch is
    *         currently not possible (i.e., the radio is in sleep mode)
    */
-  Time DoChannelSwitch (void);
+  Time GetDelayUntilChannelSwitch (void);
+  /**
+   * Actually switch channel based on the stored channel settings.
+   */
+  virtual void DoChannelSwitch (void);
 
   /**
    * Check if PHY state should move to CCA busy state based on current
@@ -1167,7 +1123,7 @@
    * Add the PHY entity to the map of supported PHY entities for the
    * given modulation class for the WifiPhy instance.
    * This is a wrapper method used to check that the PHY entity is
-   * in the static map of implemented PHY entities (\see m_staticPhyEntities).
+   * in the static map of implemented PHY entities (\see GetStaticPhyEntities).
    * In addition, child classes can add their own PHY entities.
    *
    * \param modulation the modulation class
@@ -1376,20 +1332,17 @@
   TracedCallback<Ptr<const Packet>, uint16_t /* frequency (MHz) */, WifiTxVector, MpduInfo, uint16_t /* STA-ID*/> m_phyMonitorSniffTxTrace;
 
   /**
-   * Map of __implemented__ PHY entities. This is used to compute the different
+   * \return the map of __implemented__ PHY entities.
+   * This is used to compute the different
    * amendment-specific parameters in a static manner.
    * For PHY entities supported by a given WifiPhy instance,
    * \see m_phyEntities.
    */
-  static std::map<WifiModulationClass, Ptr<PhyEntity> > m_staticPhyEntities;
+  static std::map<WifiModulationClass, Ptr<PhyEntity> > & GetStaticPhyEntities (void);
 
-  WifiPhyStandard m_standard;               //!< WifiPhyStandard
+  WifiStandard m_standard;                  //!< WifiStandard
   WifiPhyBand m_band;                       //!< WifiPhyBand
-  uint16_t m_initialFrequency;              //!< Store frequency until initialization (MHz)
-  uint8_t m_initialChannelNumber;           //!< Store channel number until initialization
-  uint16_t m_initialChannelWidth;           //!< Store channel width (MHz) until initialization
-  uint8_t m_initialPrimary20Index;          //!< Store the index of primary20 until initialization
-
+  ChannelTuple m_channelSettings;           //!< Store operating channel settings until initialization
   WifiPhyOperatingChannel m_operatingChannel;       //!< Operating channel
   std::vector<uint16_t> m_supportedChannelWidthSet; //!< Supported channel width set (MHz)
 
@@ -1420,7 +1373,7 @@
 
   Time m_channelSwitchDelay;     //!< Time required to switch between channel
 
-  Ptr<NetDevice>     m_device;   //!< Pointer to the device
+  Ptr<WifiNetDevice> m_device;   //!< Pointer to the device
   Ptr<MobilityModel> m_mobility; //!< Pointer to the mobility model
 
   Ptr<FrameCaptureModel> m_frameCaptureModel;           //!< Frame capture model
